﻿DeclareModule DispWnd
  
  Declare Open()
  Declare Event_Handler(Event) 
  
EndDeclareModule

Module DispWnd
  
  Global wnd_Display
  Global MyGrid, GridVScroll, GridHScroll, txtEdit, strEdit, btnOk
  Global Dim GridData.s(1,1)
  Global ActiveRow.i,ActiveColumn.i
  
 Procedure LoadGridData()
  ;{ ==Load Grid1Data Comment==============================
  ;Procedure to load data for displayed grid number 1
  ;Loads data to be displayed into predefined grid data array
  ;Resizes grid data array to suit
  ;This determines the number of rows and columns for the grid display
  ;}
  
  
  Define Rows.i,Columns.i
  Define RowLoop.i,ColumnLoop.i
  
  ;Release The data Array
  FreeArray(GridData())
  
  ;Work out number of columns etc reuired and setup array
  Rows = 20
  Columns = 11
  Global Dim Griddata.s(Rows,Columns)
  
  ;Now set the header Texts 
  ;Column Headers Allways on Row 0
  For ColumnLoop = 1 To Columns
    Griddata(0,ColumnLoop) = Chr(ColumnLoop + 64)
  Next ColumnLoop
  
  ;Row Headers Allways on Column 0
  For RowLoop = 1 To Rows
    Griddata(RowLoop,0) = Str(RowLoop)
  Next RowLoop
  
  ;Then add the data   
  For RowLoop = 1 To Rows
    For ColumnLoop = 1 To Columns
      GridData(RowLoop,ColumnLoop) = "Row " + Str(Rowloop) + " Col " + Str(ColumnLoop)
    Next ColumnLoop
  Next RowLoop
  
EndProcedure 
     
Procedure.i Open()

  wnd_Display = OpenWindow(#PB_Any, 30, 30, 600, 410, "Grid 3 Display Window", #PB_Window_SystemMenu)
  txtEdit = TextGadget(#PB_Any, 10, 10, 70, 20, "Edit Text", #PB_Text_Right)
  strEdit = StringGadget(#PB_Any, 90, 10, 140, 20, "")
  btnOk = ButtonGadget(#PB_Any, 240, 10, 60, 20, "Ok")  
  ;Grid Definition
  LoadGridData() ;Allways First as it defines the number of rows and columns to be displayed
  ;Add The canvas gadget for the grid The number returned references this grid
  MyGrid = EasyGrid::New(10,40,550,340,ArraySize(Griddata(),1),ArraySize(Griddata(),2))
  ;Grid Modifiers Here After Creation
  EasyGrid::SetAutoColresize(MyGrid,#True)
  ;Scrollbars added here. If the grid is not to be scrollable miss these and delete the eventhandlers
  GridVScroll = ScrollBarGadget(#PB_Any, 560, 40, 20, 340, 1, ArraySize(Griddata(),1), 5, #PB_ScrollBar_Vertical)
  GridHScroll = ScrollBarGadget(#PB_Any, 10, 380, 550, 20, 1, ArraySize(Griddata(),2), 1)
  EasyGrid::Drawgrid(MyGrid, GridData()) 
  ProcedureReturn wnd_Display  
  
EndProcedure

Procedure Event_Handler(Event)
  
  If event = #PB_Event_CloseWindow
    CloseWindow(wnd_Display)
  EndIf
  
  If event = #PB_Event_Gadget
    
    Select EventGadget()
      
      Case GridVScroll
        ;Scroll the rows of Grid
        EasyGrid::SetFirstRow(MyGrid,GetGadgetState(GridVScroll))
        ;Redraw needed after a scroll
        EasyGrid::Drawgrid(MyGrid, GridData())          
          
      Case GridHScroll
        ;Scroll the columns of Grid 1
        EasyGrid::SetFirstCol(MyGrid,GetGadgetState(GridHScroll))
        ;Redraw needed after a scroll
        EasyGrid::Drawgrid(MyGrid, GridData())   
      
      Case MyGrid

        Select EventType()
          Case #PB_EventType_LeftClick 
            ActiveRow = EasyGrid::GetRow(MyGrid,GetGadgetAttribute(MyGrid, #PB_Canvas_MouseY))
            ActiveColumn = EasyGrid::GetCol(MyGrid,GetGadgetAttribute(MyGrid, #PB_Canvas_MouseX))
            SetGadgetText(strEdit,GridData(ActiveRow, ActiveColumn))

        EndSelect
        
      Case btnOk
        GridData(ActiveRow, ActiveColumn) = GetGadgetText(strEdit)
        ;Redraw to show new text
        EasyGrid::Drawgrid(MyGrid, GridData()) 
        
        Debug "eDIT"
    EndSelect
  EndIf

 EndProcedure

EndModule

; IDE Options = PureBasic 5.50 (Windows - x64)
; CursorPosition = 98
; FirstLine = 34
; Folding = j-
; EnableXP